@use "sass:list";
@use "sass:map";
@use "sass:meta";
@use "./throw";

/// Safely gets a value from a Sass map.
/// It will return the `DEFAULT` if no key is specified.
/// @example scss
///   $colors: (
///     DEFAULT: #161616,
///     white: #ffffff,
///   );
///
///   @mixin text-color($key: null) {
///     color: default-get($colors, $key);
///   }
/// @param {Map} $map - Any Sass map
/// @param {String | Null} $key [null] - Optional top-level key
/// @param {Arglist} $keys - Optional nested keys
/// @return {Unknown} - Whatever is found in the map
/// @group util
@function default-get($map, $key: null, $keys...) {
  @if not $key {
    @if map.has-key($map: $map, $key: DEFAULT) {
      @return map.get($map: $map, $key: DEFAULT);
    }

    @return throw.error(
      $message: "Key 'DEFAULT' does not exist in map '#{meta.inspect($map)}'.",
      $source: "default-get()"
    );
  }

  @if not map.has-key($map: $map, $key: $key) {
    @return throw.error(
      $message: "Key '#{$key}' does not exist in map '#{meta.inspect($map)}'.",
      $source: "default-get()"
    );
  }

  $value: map.get(
    $map: $map,
    $key: $key,
  );
  @if list.length($list: $keys) > 0 {
    @return default-get($value, $keys...); // 🔄 Recursive
  }

  @return $value;
}
